mono compatibility issues

Tips and discussions about using OpenSim
Post Reply
User avatar
Kayaker Magic
Posts: 324
Joined: Sun Dec 01, 2013 8:40 am
Has thanked: 46 times
Been thanked: 342 times

mono compatibility issues

Post by Kayaker Magic » Wed Mar 16, 2016 10:38 pm

I have a Kitely Market customer who was unable to get my surfing wave to work.
Fortunately he let me HG to his sim and look into the problem.
I discovered that there was a line in my code where I said something like:
if (vec.x==0.0)
and the LSL compiler was giving a mono error saying it could not compare a float to a double!
I changed the 0.0 into 0, and the compiler accepted it and I was able to give my customer a working version.
From the error message, I got the impression that he was running on a server with mono 4.0
What version of mono is running on the Kitely servers?
I've asked the customer to talk to his sysadmin and find out for me what version his SIM is running on.
I asked my home Linux server what version of mono my OSgrid sim is running on and it is 3.0.4
I hope mono/.net compatibility issues are not going to make selling scripts on the Kitely Market difficult....
User avatar
Ilan Tochner
Posts: 4561
Joined: Sun Dec 23, 2012 8:44 am
Has thanked: 2239 times
Been thanked: 2407 times
Contact:

Re: mono compatibility issues

Post by Ilan Tochner » Thu Mar 17, 2016 1:14 am

Hi Kayaker,

Different grids run different Mono versions and girds change their Mono versions over time. Kitely has also changed the Mono version we use several times and have often held back on upgrading Mono versions until OpenSim errors that occurred with the newer version were resolved by an even newer OpenSim or Mono version. In other words, what we use now may change the next time we roll out a site upgrade so you can't make any assumptions regarding which OpenSim or Mono version your code will be running on. If there are known OpenSim and/or Mono versions where it won't work you should list them in your Kitely Market product listings and work to find ways to ensure that they do work on those versions (especially if they are newer release versions of OpenSim and/or Mono).

If type casting can be an issue (which apparently it can) then you need to ensure your code does not use implicit type casting.

As a side note, to avoid any misunderstanding of my aforementioned comment, we have no plans to upgrade to OpenSim 0.9.0 before it is officially released.
User avatar
Kayaker Magic
Posts: 324
Joined: Sun Dec 01, 2013 8:40 am
Has thanked: 46 times
Been thanked: 342 times

Re: mono compatibility issues

Post by Kayaker Magic » Thu Mar 17, 2016 5:09 am

Understanding all that, can you please tell me which version of mono you are currently using, with the understanding that it may change tomorrow. I would like to characterize the problem if I can.
And notice that I had problems when I thought I was not type casting, by using a floating point zero, and when I forced the compiler to do a typecast from an integer constant, it seemed to do the correct thing and stopped giving me an error!
User avatar
Oren Hurvitz
Posts: 297
Joined: Sun Dec 23, 2012 8:42 am
Has thanked: 8 times
Been thanked: 348 times

Re: mono compatibility issues

Post by Oren Hurvitz » Thu Mar 17, 2016 5:59 am

Hi Kayaker,

We are currently using Mono 4.2.1.
Post Reply